<template>
  <v-row>
    <v-col>
      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="DocumentListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddDocumentBtn" @click="createDocument()">
          <v-icon left>add</v-icon>
          Ajouter un document
        </v-btn>
      </div>

      <v-data-table :headers="headers" :items="documentsFiltered" disable-pagination hide-default-footer density="compact"
        loading-text="Chargement des documents ..." no-results-text="Aucun document ne correspond à cette recherche"
        no-data-text="Aucun document ne correspond à cette recherche" class="airvam-table">

        <template #item.name="{ item }">
          {{ decodeURI(item.name) }}
        </template>

        <template #item.actions="{ item }">
          <div class="d-flex">
            <v-btn icon size="x-small" data-cy="EditDocumentBtn" @click="askEditDocument(item)" class="mr-1 action" flat>
              <v-icon>edit</v-icon>
            </v-btn>

            <v-btn icon size="x-small" class="action" data-cy="DeleteDocumentBtn" @click="askDeleteDocument(item)" flat>
              <v-icon>delete</v-icon>
            </v-btn>
          </div>
        </template>
      </v-data-table>

      <LazyAdminDocumentsDocumentDialog v-if="documentDialog && editedDocument" v-model="documentDialog"
        :document="editedDocument" @confirm="createEditDocument" @close="close" />

      <LazyConfirmDialog v-if="documentDialogDelete" v-model="documentDialogDelete"
        :dialogText="documentDialogDeleteText" :dialogTitle="'Suppression d\'un document'" @confirm="deleteDocument"
        @close="close" />
    </v-col>
  </v-row>
</template>

<script setup lang="ts">

import { debounce } from "~/components/mixins/utilsMixin";
import { Document } from "~/dto/document.dto";

const { $api, $toast } = useNuxtApp();
const store = useStore();
const { documents } = storeToRefs(useStore());

const documentDialog = ref(false);
const documentDialogDelete = ref(false);
const documentDialogDeleteText = ref('');
const editedDocument: Ref<Document | null> = ref(null);
const documentsFiltered: Ref<Document[]> = ref([]);
const query = ref('');
const headers: Ref<any[]> = ref([
  { title: 'Nom', value: 'name' },
  { title: 'Catégorie', value: 'category' },
  { title: '', value: 'actions', sortable: false },
]);


const createDocument = () => {
  const document = new Document();
  askEditDocument(document);
}

const askEditDocument = (item: Document) => {
  editedDocument.value = Object.assign({}, item);
  editedDocument.value.name = editedDocument.value.name ? decodeURI(editedDocument.value.name) : editedDocument.value.name;
  documentDialog.value = true;
}

const askDeleteDocument = (item: Document) => {
  editedDocument.value = Object.assign({}, item);
  documentDialogDeleteText.value = `Êtes-vous sûr de vouloir supprimer le document "${decodeURI(editedDocument.value.name)}" ?`;
  documentDialogDelete.value = true;
}

const close = () => {
  documentDialogDelete.value = false;
  documentDialog.value = false;
  editedDocument.value = null;
}

const createEditDocument = async () => {
  try {
    const documentReturned = editedDocument.value?.id ? await $api.document.update(editedDocument.value, editedDocument.value.id)
      : await $api.document.create(editedDocument.value);
    store.editList({ listName: 'documents', item: documentReturned });
    $toast.success(editedDocument.value?.id ? "Document modifié" : "Document crée");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedDocument.value?.id ? "Erreur lors de l'édition d'un document" : "Erreur lors de la création d'un document");
  }
  filter();
  close();
}

const deleteDocument = async () => {
  try {
    await $api.document.delete(editedDocument.value?.id);
    await store.deleteFromList({ listName: 'documents', item: editedDocument.value });
    $toast.success("Document supprimé");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error("Erreur lors de la suppression d'un document");
  }
  filter();
  close();
}

const filter = () => {
  documentsFiltered.value = [...documents.value].filter(d => {
    if (!query.value || query.value === '') {
      return true;
    }
    return d.name?.toUpperCase().includes(query.value.toUpperCase())
      || d.category?.toUpperCase().includes(query.value.toUpperCase())
  });
}

filter();

watch(query, debounce(function () {
  filter();
}, 300));
</script>
